aboutsummaryrefslogtreecommitdiff
path: root/gen
diff options
context:
space:
mode:
authorThomas Voss <mail@thomasvoss.com> 2024-04-06 13:06:21 +0200
committerThomas Voss <mail@thomasvoss.com> 2024-04-06 13:06:21 +0200
commitb5b63552ff48ceb440a8dac590628ffe4e5e5751 (patch)
treea769314ea1247a3260ac0a305c94fcaff40ac6b0 /gen
parent03f69018340f0fae95556321a3d89dcb49910ebe (diff)
Add uprop_get_nv()
Diffstat (limited to 'gen')
-rwxr-xr-xgen/data-files1
-rwxr-xr-xgen/prop/nv63
2 files changed, 64 insertions, 0 deletions
diff --git a/gen/data-files b/gen/data-files
index 3c0d9e3..a3df9f3 100755
--- a/gen/data-files
+++ b/gen/data-files
@@ -12,6 +12,7 @@ DerivedCoreProperties.txt
DerivedNormalizationProps.txt
emoji/emoji-data.txt
extracted/DerivedBinaryProperties.txt
+extracted/DerivedNumericValues.txt
PropList.txt
UnicodeData.txt
'
diff --git a/gen/prop/nv b/gen/prop/nv
new file mode 100755
index 0000000..713ea40
--- /dev/null
+++ b/gen/prop/nv
@@ -0,0 +1,63 @@
+#!/bin/sh
+
+set -e
+cd "${0%/*}/../.."
+exec >lib/unicode/prop/uprop_get_nv.c
+
+gawk '
+BEGIN {
+ FS = "( *#.*| +; +)"
+
+ print "/* This file is autogenerated by gen/prop/nv; DO NOT EDIT. */"
+ print ""
+ print "#include <float.h>"
+ print ""
+ print "#include \"__bsearch.h\""
+ print "#include \"macros.h\""
+ print "#include \"rune.h\""
+ print "#include \"unicode/prop.h\""
+ print ""
+}
+
+/^[^#]/ {
+ n = split($1, a, /\.\./)
+ lo = strtonum("0X" a[1])
+ hi = strtonum("0X" a[n])
+
+ for (i = lo; i <= hi; i++) {
+ gsub(/^; /, "", $3)
+ props[i] = $3
+ }
+}
+
+END {
+ print "static constexpr double lookup_lat1[] = {"
+ for (i = 0; i < 0x100; i++) {
+ if (i % 8 == 0)
+ printf "\t"
+ printf "%3s,%s", props[i] ? props[i] : "NAN", i % 8 == 7 ? "\n" : " "
+ }
+ print "};"
+ print ""
+ print "static const struct {"
+ print "\trune k;"
+ print "\tdouble v;"
+ print "} lookup[] = {"
+
+ for (i = 0x100; i <= 0x10FFFF; i++) {
+ if (!props[i])
+ continue
+ printf "\t{RUNE_C(0x%06X), %s},\n", i, props[i]
+ }
+
+ print "};"
+ print ""
+ print "__MLIB_DEFINE_BSEARCH_KV(double, lookup, NAN)"
+ print ""
+ print "double"
+ print "uprop_get_nv(rune ch)"
+ print "{"
+ print "\treturn ch < lengthof(lookup_lat1) ? lookup_lat1[ch] : mlib_lookup_kv(ch);"
+ print "}"
+}
+' data/DerivedNumericValues.txt